Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 574)
+++ lemon/full_graph.h	(revision 440)
@@ -158,6 +158,7 @@
   /// constant space in memory.
   ///
-  /// This class fully conforms to the \ref concepts::Digraph
-  /// "Digraph concept".
+  /// This class conforms to the \ref concepts::Digraph "Digraph" concept
+  /// and it also has an important extra feature that its maps are
+  /// real \ref concepts::ReferenceMap "reference map"s.
   ///
   /// The \c FullDigraph and \c FullGraph classes are very similar,
@@ -527,5 +528,7 @@
   /// space in memory.
   ///
-  /// This class fully conforms to the \ref concepts::Graph "Graph concept".
+  /// This class conforms to the \ref concepts::Graph "Graph" concept
+  /// and it also has an important extra feature that its maps are
+  /// real \ref concepts::ReferenceMap "reference map"s.
   ///
   /// The \c FullGraph and \c FullDigraph classes are very similar,
Index: lemon/glpk.cc
===================================================================
--- lemon/glpk.cc	(revision 568)
+++ lemon/glpk.cc	(revision 558)
@@ -32,5 +32,4 @@
     lp = glp_create_prob();
     glp_create_index(lp);
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -41,5 +40,4 @@
     rows = other.rows;
     cols = other.cols;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -529,24 +527,4 @@
   }
 
-  void GlpkBase::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_level = GLP_MSG_OFF;
-      break;
-    case MESSAGE_ERROR:
-      _message_level = GLP_MSG_ERR;
-      break;
-    case MESSAGE_WARNING:
-      _message_level = GLP_MSG_ERR;
-      break;
-    case MESSAGE_NORMAL:
-      _message_level = GLP_MSG_ON;
-      break;
-    case MESSAGE_VERBOSE:
-      _message_level = GLP_MSG_ALL;
-      break;
-    }
-  }
-
   GlpkBase::FreeEnvHelper GlpkBase::freeEnvHelper;
 
@@ -555,4 +533,5 @@
   GlpkLp::GlpkLp()
     : LpBase(), LpSolver(), GlpkBase() {
+    messageLevel(MESSAGE_NO_OUTPUT);
     presolver(false);
   }
@@ -560,4 +539,5 @@
   GlpkLp::GlpkLp(const GlpkLp& other)
     : LpBase(other), LpSolver(other), GlpkBase(other) {
+    messageLevel(MESSAGE_NO_OUTPUT);
     presolver(false);
   }
@@ -583,5 +563,18 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
     smcp.presolve = _presolve;
 
@@ -612,5 +605,18 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
     smcp.meth = GLP_DUAL;
     smcp.presolve = _presolve;
@@ -853,12 +859,18 @@
   }
 
+  void GlpkLp::messageLevel(MessageLevel m) {
+    _message_level = m;
+  }
+
   // GlpkMip members
 
   GlpkMip::GlpkMip()
     : LpBase(), MipSolver(), GlpkBase() {
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
   GlpkMip::GlpkMip(const GlpkMip& other)
     : LpBase(), MipSolver(), GlpkBase(other) {
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
@@ -889,5 +901,18 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
     smcp.meth = GLP_DUAL;
 
@@ -914,5 +939,18 @@
     glp_init_iocp(&iocp);
 
-    iocp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      iocp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      iocp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      iocp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      iocp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
 
     if (glp_intopt(lp, &iocp) != 0) return UNSOLVED;
@@ -965,3 +1003,7 @@
   const char* GlpkMip::_solverName() const { return "GlpkMip"; }
 
+  void GlpkMip::messageLevel(MessageLevel m) {
+    _message_level = m;
+  }
+
 } //END OF NAMESPACE LEMON
Index: lemon/glpk.h
===================================================================
--- lemon/glpk.h	(revision 568)
+++ lemon/glpk.h	(revision 557)
@@ -100,6 +100,4 @@
 
     virtual void _clear();
-
-    virtual void _messageLevel(MessageLevel level);
 
   private:
@@ -114,8 +112,4 @@
     
     static FreeEnvHelper freeEnvHelper;
-
-  protected:
-    
-    int _message_level;
     
   public:
@@ -198,4 +192,28 @@
     void presolver(bool presolve);
 
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
+
+  private:
+
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
   };
 
@@ -227,4 +245,28 @@
     virtual Value _getSolValue() const;
 
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
+
+  private:
+
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
   };
 
Index: lemon/gomory_hu.h
===================================================================
--- lemon/gomory_hu.h	(revision 588)
+++ lemon/gomory_hu.h	(revision 534)
@@ -43,13 +43,15 @@
   /// between these nodes. Moreover the components obtained by removing
   /// this edge from the tree determine the corresponding minimum cut.
+  ///
   /// Therefore once this tree is computed, the minimum cut between any pair
   /// of nodes can easily be obtained.
   /// 
   /// The algorithm calculates \e n-1 distinct minimum cuts (currently with
-  /// the \ref Preflow algorithm), thus it has \f$O(n^3\sqrt{e})\f$ overall
-  /// time complexity. It calculates a rooted Gomory-Hu tree.
-  /// The structure of the tree and the edge weights can be
-  /// obtained using \c predNode(), \c predValue() and \c rootDist().
-  /// The functions \c minCutMap() and \c minCutValue() calculate
+  /// the \ref Preflow algorithm), therefore the algorithm has
+  /// \f$(O(n^3\sqrt{e})\f$ overall time complexity. It calculates a
+  /// rooted Gomory-Hu tree, its structure and the weights can be obtained
+  /// by \c predNode(), \c predValue() and \c rootDist().
+  /// 
+  /// The members \c minCutMap() and \c minCutValue() calculate
   /// the minimum cut and the minimum cut value between any two nodes
   /// in the graph. You can also list (iterate on) the nodes and the
@@ -57,6 +59,6 @@
   ///
   /// \tparam GR The type of the undirected graph the algorithm runs on.
-  /// \tparam CAP The type of the edge map containing the capacities.
-  /// The default map type is \ref concepts::Graph::EdgeMap "GR::EdgeMap<int>".
+  /// \tparam CAP The type of the edge map describing the edge capacities.
+  /// It is \ref concepts::Graph::EdgeMap "GR::EdgeMap<int>" by default.
 #ifdef DOXYGEN
   template <typename GR,
@@ -69,7 +71,7 @@
   public:
 
-    /// The graph type of the algorithm
+    /// The graph type
     typedef GR Graph;
-    /// The capacity map type of the algorithm
+    /// The type of the edge capacity map
     typedef CAP Capacity;
     /// The value type of capacities
@@ -116,5 +118,5 @@
     /// \brief Constructor
     ///
-    /// Constructor.
+    /// Constructor
     /// \param graph The undirected graph the algorithm runs on.
     /// \param capacity The edge capacity map.
@@ -129,5 +131,5 @@
     /// \brief Destructor
     ///
-    /// Destructor.
+    /// Destructor
     ~GomoryHu() {
       destroyStructures();
@@ -142,9 +144,9 @@
       _root = NodeIt(_graph);
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        (*_pred)[n] = _root;
-        (*_order)[n] = -1;
-      }
-      (*_pred)[_root] = INVALID;
-      (*_weight)[_root] = std::numeric_limits<Value>::max(); 
+	_pred->set(n, _root);
+	_order->set(n, -1);
+      }
+      _pred->set(_root, INVALID);
+      _weight->set(_root, std::numeric_limits<Value>::max()); 
     }
 
@@ -163,20 +165,20 @@
 	fa.runMinCut();
 
-	(*_weight)[n] = fa.flowValue();
+	_weight->set(n, fa.flowValue());
 
 	for (NodeIt nn(_graph); nn != INVALID; ++nn) {
 	  if (nn != n && fa.minCut(nn) && (*_pred)[nn] == pn) {
-	    (*_pred)[nn] = n;
+	    _pred->set(nn, n);
 	  }
 	}
 	if ((*_pred)[pn] != INVALID && fa.minCut((*_pred)[pn])) {
-	  (*_pred)[n] = (*_pred)[pn];
-	  (*_pred)[pn] = n;
-	  (*_weight)[n] = (*_weight)[pn];
-	  (*_weight)[pn] = fa.flowValue();
-	}
-      }
-
-      (*_order)[_root] = 0;
+	  _pred->set(n, (*_pred)[pn]);
+	  _pred->set(pn, n);
+	  _weight->set(n, (*_weight)[pn]);
+	  _weight->set(pn, fa.flowValue());	
+	}
+      }
+
+      _order->set(_root, 0);
       int index = 1;
 
@@ -189,5 +191,5 @@
 	}
 	while (!st.empty()) {
-	  (*_order)[st.back()] = index++;
+	  _order->set(st.back(), index++);
 	  st.pop_back();
 	}
@@ -214,5 +216,5 @@
     ///The results of the algorithm can be obtained using these
     ///functions.\n
-    ///\ref run() should be called before using them.\n
+    ///\ref run() "run()" should be called before using them.\n
     ///See also \ref MinCutNodeIt and \ref MinCutEdgeIt.
 
@@ -221,11 +223,17 @@
     /// \brief Return the predecessor node in the Gomory-Hu tree.
     ///
-    /// This function returns the predecessor node of the given node
+    /// This function returns the predecessor node in the Gomory-Hu tree.
+    /// If the node is
+    /// the root of the Gomory-Hu tree, then it returns \c INVALID.
+    Node predNode(const Node& node) {
+      return (*_pred)[node];
+    }
+
+    /// \brief Return the distance from the root node in the Gomory-Hu tree.
+    ///
+    /// This function returns the distance of \c node from the root node
     /// in the Gomory-Hu tree.
-    /// If \c node is the root of the tree, then it returns \c INVALID.
-    ///
-    /// \pre \ref run() must be called before using this function.
-    Node predNode(const Node& node) const {
-      return (*_pred)[node];
+    int rootDist(const Node& node) {
+      return (*_order)[node];
     }
 
@@ -233,32 +241,16 @@
     /// Gomory-Hu tree.
     ///
-    /// This function returns the weight of the predecessor edge of the 
-    /// given node in the Gomory-Hu tree.
-    /// If \c node is the root of the tree, the result is undefined.
-    ///
-    /// \pre \ref run() must be called before using this function.
-    Value predValue(const Node& node) const {
+    /// This function returns the weight of the predecessor edge in the
+    /// Gomory-Hu tree.  If the node is the root, the result is undefined.
+    Value predValue(const Node& node) {
       return (*_weight)[node];
     }
 
-    /// \brief Return the distance from the root node in the Gomory-Hu tree.
-    ///
-    /// This function returns the distance of the given node from the root
-    /// node in the Gomory-Hu tree.
-    ///
-    /// \pre \ref run() must be called before using this function.
-    int rootDist(const Node& node) const {
-      return (*_order)[node];
-    }
-
     /// \brief Return the minimum cut value between two nodes
     ///
-    /// This function returns the minimum cut value between the nodes
-    /// \c s and \c t. 
-    /// It finds the nearest common ancestor of the given nodes in the
-    /// Gomory-Hu tree and calculates the minimum weight edge on the
-    /// paths to the ancestor.
-    ///
-    /// \pre \ref run() must be called before using this function.
+    /// This function returns the minimum cut value between two nodes. The
+    /// algorithm finds the nearest common ancestor in the Gomory-Hu
+    /// tree and calculates the minimum weight edge on the paths to
+    /// the ancestor.
     Value minCutValue(const Node& s, const Node& t) const {
       Node sn = s, tn = t;
@@ -283,21 +275,14 @@
     /// \c s to \c true and the other nodes to \c false.
     ///
-    /// For higher level interfaces see MinCutNodeIt and MinCutEdgeIt.
-    ///
-    /// \param s The base node.
-    /// \param t The node you want to separate from node \c s.
-    /// \param cutMap The cut will be returned in this map.
-    /// It must be a \c bool (or convertible) \ref concepts::ReadWriteMap
-    /// "ReadWriteMap" on the graph nodes.
-    ///
-    /// \return The value of the minimum cut between \c s and \c t.
-    ///
-    /// \pre \ref run() must be called before using this function.
+    /// For higher level interfaces, see MinCutNodeIt and MinCutEdgeIt.
     template <typename CutMap>
-    Value minCutMap(const Node& s, ///< 
+    Value minCutMap(const Node& s, ///< The base node.
                     const Node& t,
-                    ///< 
+                    ///< The node you want to separate from node \c s.
                     CutMap& cutMap
-                    ///< 
+                    ///< The cut will be returned in this map.
+                    /// It must be a \c bool (or convertible) 
+                    /// \ref concepts::ReadWriteMap "ReadWriteMap"
+                    /// on the graph nodes.
                     ) const {
       Node sn = s, tn = t;
@@ -325,7 +310,7 @@
 
       typename Graph::template NodeMap<bool> reached(_graph, false);
-      reached[_root] = true;
+      reached.set(_root, true);
       cutMap.set(_root, !s_root);
-      reached[rn] = true;
+      reached.set(rn, true);
       cutMap.set(rn, s_root);
 
@@ -354,5 +339,5 @@
     
     /// This iterator class lists the nodes of a minimum cut found by
-    /// GomoryHu. Before using it, you must allocate a GomoryHu class
+    /// GomoryHu. Before using it, you must allocate a GomoryHu class,
     /// and call its \ref GomoryHu::run() "run()" method.
     ///
@@ -451,5 +436,5 @@
     
     /// This iterator class lists the edges of a minimum cut found by
-    /// GomoryHu. Before using it, you must allocate a GomoryHu class
+    /// GomoryHu. Before using it, you must allocate a GomoryHu class,
     /// and call its \ref GomoryHu::run() "run()" method.
     ///
@@ -463,6 +448,6 @@
     ///   value+=capacities[e];
     /// \endcode
-    /// The result will be the same as the value returned by
-    /// \ref GomoryHu::minCutValue() "gom.minCutValue(s,t)".
+    /// the result will be the same as it is returned by
+    /// \ref GomoryHu::minCutValue() "gom.minCutValue(s,t)"
     class MinCutEdgeIt
     {
@@ -484,8 +469,4 @@
       
     public:
-      /// Constructor
-
-      /// Constructor.
-      ///
       MinCutEdgeIt(GomoryHu const &gomory,
                    ///< The GomoryHu class. You must call its
@@ -498,5 +479,5 @@
                    ///< If it is \c true (default) then the listed arcs
                    ///  will be oriented from the
-                   ///  nodes of the component containing \c s,
+                   ///  the nodes of the component containing \c s,
                    ///  otherwise they will be oriented in the opposite
                    ///  direction.
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 576)
+++ lemon/graph_to_eps.h	(revision 550)
@@ -269,16 +269,20 @@
     ///\image html nodeshape_1.png
     ///\image latex nodeshape_1.eps "SQUARE shape (1)" width=2cm
+    ///
     SQUARE=1,
     /// = 2
     ///\image html nodeshape_2.png
     ///\image latex nodeshape_2.eps "DIAMOND shape (2)" width=2cm
+    ///
     DIAMOND=2,
     /// = 3
     ///\image html nodeshape_3.png
-    ///\image latex nodeshape_3.eps "MALE shape (3)" width=2cm
+    ///\image latex nodeshape_2.eps "MALE shape (4)" width=2cm
+    ///
     MALE=3,
     /// = 4
     ///\image html nodeshape_4.png
-    ///\image latex nodeshape_4.eps "FEMALE shape (4)" width=2cm
+    ///\image latex nodeshape_2.eps "FEMALE shape (4)" width=2cm
+    ///
     FEMALE=4
   };
Index: lemon/grid_graph.h
===================================================================
--- lemon/grid_graph.h	(revision 574)
+++ lemon/grid_graph.h	(revision 550)
@@ -498,5 +498,7 @@
   ///
   /// This graph type fully conforms to the \ref concepts::Graph
-  /// "Graph concept".
+  /// "Graph" concept, and it also has an important extra feature
+  /// that its maps are real \ref concepts::ReferenceMap
+  /// "reference map"s.
   class GridGraph : public ExtendedGridGraphBase {
   public:
